import random
import os

flag = (os.getenv("FLAG") or "mctf{flag}").encode()

flag = flag[4:-1]

class LFSR:
    def __init__(self, seed, tap):
        self.state = [(seed>>_)&1 for _ in range(32)]
        self.tap = tap
    def next(self):
        n = self.state.pop()
        self.state.insert(0, n^self.state[self.tap])
        return n
    def encrypt(self, s):
        ct = b''
        for c in s:
            n = int(''.join(list(map(str,[lfsr.next() for _ in range(8)]))), 2)
            ct+=bytes([c^n])
        return ct

lfsr = LFSR(random.randint(0, 1<<32), random.randint(0, 31))
print(lfsr.encrypt(flag))
print(lfsr.encrypt(input("Let me encrypt that for you: ").encode()))
